package io.zipcoder.blue_coin_application.model;

import com.google.gson.GsonBuilder;

import java.util.ArrayList;
import java.util.List;

public class Blockchain {
    private static List<Block> blockchain = new ArrayList<>();

    public String chainToJson() {
        return new GsonBuilder()
                .setPrettyPrinting()
                .create()
                .toJson(blockchain);
    }

    public static List<Block> getBlockchain() {
        return blockchain;
    }

    public static void abbBlockToChain(Block block) {
        blockchain.add(block);
    }

    public static Block getBlockFromChain(int i) {
        return blockchain.get(i);
    }

    public static int getChainSize() {
        return blockchain.size();
    }

    public static boolean isChainValid() {
        Block currentBlock;
        Block previousBlock;
        for (int i = 1; i < blockchain.size()-1; i++) {
            currentBlock = blockchain.get(i);
            previousBlock = blockchain.get(i-1);
            if(!currentBlock.getHash().equals(currentBlock.calculateHash())) {
                return false;
            }
            if(!previousBlock.getHash().equals(currentBlock.getPreviousHash())) {
                return false;
            }
        }
        return true;
    }
}